#define semmi 0
#define paraszt 1
#define futo 2
#define bastya 3
#define kirno 4
#define kir 5
#define lo 6
#define mply 4
int arak[6]={100,325,500,900,10000,300};
// 1=feher 2=fekete

#define COORDTONAME(A,B) (A+(B<<3)+1)
#define PIECE(A,B) tbl->tabla[B][A]
#define XPIECE(A) ((char*)(tbl->tabla))[A]
#define PCOLOR(A,B) (PIECE(A,B) & 1)
#define PTYPE(A,B) (PIECE(A,B) >> 1)
#define ISEMPTY(A,B) (PIECE(A,B)==0)
struct ttabla
{  
      int tabla[8][8];
      int enp,bmoved;
};
int IsMoveOk(ttabla *tbl,int x1,int y1,int x2,int y2,int tcc);
int SAttack(ttabla *tbl,int x, int y, int col)
{
    int i,j;
    for (i=0;i<8;i++) for (j=0;j<8;j++) {
        if (PCOLOR(i,j)==col) if (IsMoveOk(tbl, i,j, x,y,0)) return 1;
    }     
    return 0;
}
int sgn(int p) { if (p>0) {return 1;} else { if (!p) {return 0;} else return -1; } }
int IsMoveOk(ttabla *tbl,int x1,int y1,int x2,int y2,int tcc)
{
    int ey,ex,vx,vy,tp;
    
    if ((x1<0)||(x1>7)||(y1<0)||(y1>7)||(x2<0)||(x2>7)||(y2<0)||(y2>7)) return 0; 
    // ^^ ha a koordinatak kiesnek a tablarol
    if (ISEMPTY(x1,y1) || ((!ISEMPTY(x2,y2))&&(PCOLOR(x1,y1)==PCOLOR(x2,y2)))) return 0;
    // ^^ ha nem mozgatunk semmit, vagy sajat figurat probalunk levenni
    switch (PTYPE(x1,y1)) {
           case semmi: break;
           case paraszt:         
	      ey=PCOLOR(x1,y1)?-1:1;
	      if ISEMPTY(x2,y2) {
	         if (x1!=x2) return 0;
		 // ^ ures kockara csak elore lehet lepni
		 if (!(ISEMPTY(x1,y1+ey))) return 0;
		 // ^ az elotte levo kocka ures kell legyen
		 if ((y2!=(y1+ey))&&(y2!=(y1+ey+ey))) return 0;
		 // ^ az elotte levo ket kocka valamelyike kell legyen
		 if ((!( ((y1==1)&&(ey==1)) || ((y1==6)&&(ey==-1)) ))&&(y2!=(y1+ey))) return 0;
		 // ^^ ha mar nem vagyunk jo helyen akkor nem lephetunk csak egy-et 
	      } else {
	         if (!((abs(x2-x1)==1)&&(y2==(y1+ey)))) return 0; //ha leveszunk valamit
	      } 
	      break;
	   case kirno:
	      if (!(((x1==x2)||(y1==y2))||(abs(x2-x1)==abs(y2-y1)))) return 0;
   
	      break;
	   case futo:
	      if (abs(x2-x1)!=abs(y2-y1)) return 0;
	      break; 
	   case bastya:
	      if (!((x1==x2)||(y1==y2))) return 0;
	      break;
	   case kir:
	      if (!((abs(x2-x1)<2)&&(abs(y2-y1)<2))) return 0;
	      break;
	   case lo:
	      if (((abs(x2-x1)+abs(y2-y1))!=3)||((x1==x2)||(y1==y2))) return 0; // lo lepesei
	      break;
	   default: break;   
    };
    switch (PTYPE(x1,y1)) {
           case kirno:
	   case futo:
	   case bastya:   
	      ex=sgn(x2-x1); ey=sgn(y2-y1);
	    //  printf("%d %d\n",ex,ey);
	      vx=x1+ex; vy=y1+ey;
	      while (ISEMPTY(vx,vy) && ((vx!=x2)||(vy!=y2))) {vx+=ex; vy+=ey;}
	      if ((vx!=x2)||(vy!=y2)) return 0;	   
	      break;
	   default: break;
    }
    vy=1;
    if (tcc) {
      vx=PIECE(x2,y2);
      PIECE(x2,y2)=PIECE(x1,y1);
      PIECE(x1,y1)=0;
      for (ex=0;ex<8;ex++) for (ey=0;ey<8;ey++) if ((PTYPE(ex,ey)==kir)&&(PCOLOR(ex,ey)==PCOLOR(x2,y2))) {
       if (SAttack(tbl,ex,ey,(~PCOLOR(ex,ey))&1)) vy=0; 
      }
      
      PIECE(x1,y1)=PIECE(x2,y2);
      PIECE(x2,y2)=vx;
    }
    return vy;
}
int evstatic(ttabla *tbl,int side) 
{
    int i,j,s,ss;
    s=0;
    for (i=0;i<63;i++) if (XPIECE(i)!=0) {
      ss=arak[XPIECE(i)>>1];
      if ((XPIECE(i)&1)!=side) ss=-ss;
      s+=ss;       
    }
    return s;
}

int nsearch(int side,int ply, int dobestmove, ttabla *tbl, int alpha, int beta, char useit)
{
    int i,j,k,besti,bestj,bestmovescore,score,bset;
    bset=0;
    for (i=0;i<63;i++) if (PCOLOR(i&7,(i>>3)&7)==side) {
    for (j=0;j<63;j++) if (IsMoveOk(tbl,i&7,(i>>3)&7,j&7,(j>>3)&7,1)) {
    k=PIECE(j&7,(j>>3)&7);
    PIECE(j&7,(j>>3)&7)=PIECE(i&7,(i>>3)&7);
    PIECE(i&7,(i>>3)&7)=0;
    
    if (ply<mply) {score=-nsearch((~side)&1,ply+1,0,tbl,-beta,-alpha,useit);} else { score=evstatic(tbl,side); }
    if (!bset) {bestmovescore=score; besti=i; bestj=j; bset=1;} else {
    if (score>bestmovescore) {bestmovescore=score; besti=i; bestj=j;}}
    
    PIECE(i&7,(i>>3)&7)=PIECE(j&7,(j>>3)&7);
    PIECE(j&7,(j>>3)&7)=k;
    if (useit) {
    if ( bestmovescore > alpha )   alpha = bestmovescore;
    if (alpha>=beta) {
        if (bset&&dobestmove) {PIECE(bestj&7,(bestj>>3)&7)=PIECE(besti&7,(besti>>3)&7);
             PIECE(besti&7,(besti>>3)&7)=0; }
        return alpha;
    }       
}    
    }
    }
    
    if (bset&&dobestmove) {PIECE(bestj&7,(bestj>>3)&7)=PIECE(besti&7,(besti>>3)&7);
             PIECE(besti&7,(besti>>3)&7)=0; }
    if ((!bset)&&(dobestmove)) return nsearch(side,ply+1,1,tbl,alpha,beta,0);
    return bestmovescore;	  
    
}
